<template>
  <q-page>
    <component-header
      v-if="data && data.header"
      ref="header"
      :items="data.header"
      @to="scrollToElement"
    />

    <component-platform
      v-if="data && data.platform"
      ref="platform"
      :items="data.platform"
      @to="scrollToElement"
    />

    <component-presentation
      v-if="data && data.presentation"
      ref="presentation"
      :items="data.presentation"
      @to="scrollToElement"
    />

    <component-plans
      v-if="!plansLoading && plans"
      ref="plans"
      :items="plans"
      @to="scrollToElement"
    />

    <component-testimony
      v-if="data && data.testimony"
      ref="testimony"
      :items="data.testimony"
      @to="scrollToElement"
    />

    <component-footer
      v-if="data && data.footer"
      ref="footer"
      :items="data.footer"
      @to="scrollToElement"
    />
  </q-page>
</template>

<script>
import ComponentHeader from '../components/header'
import ComponentPlatform from '../components/platform'
import ComponentPresentation from '../components/presentation'
import ComponentPlans from '../components/plans'
import ComponentTestimony from '../components/testimony'
import ComponentFooter from '../components/footer'
import { scroll } from 'quasar'

const { getScrollTarget, setScrollPosition } = scroll

export default {
  name: 'Main',
  components: {
    ComponentHeader,
    ComponentPlatform,
    ComponentPresentation,
    ComponentPlans,
    ComponentTestimony,
    ComponentFooter
  },
  props: {
    data: {
      type: Object,
      required: true
    }
  },
  asyncData: {
    plansDefault: [],
    async plans () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          baseURL: process.env.API,
          url: '/Plans',
          params: { filter: { where: { isEnable: true } } }
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  methods: {
    scrollToElement (ref) {
      const el = this.$refs[ref].$el
      const target = getScrollTarget(el)
      const offset = el.offsetTop + 70
      const duration = 300

      setScrollPosition(target, offset, duration)
    }
  }
}
</script>
